function xout=bgs_i(A,B,y)
%
% block GS using fast Toeplitz
%
[N,N1]=size(B);
N2=N/N1;
[Ny,q]=size(y);

A0=A;
y0=y;

%tstart = tic;
A1=[A0;zeros(N1*N2,N1)];
y1=[y0;zeros(N1*N2,q)];
Si=[]; % Permutation index input
si=[0:N1:N1*N2-1]';
for i=1:N1
  Si=[Si;si+i];
end
Si1=[]; % permutation index input double size
si1=[0:N1:2*N1*N2-1]';
for i=1: N1
  Si1=[Si1;si1+i];
end
So=[];
so=[0:N2:N1*N2-1]'; % permutation index output
for i=1:N2
  So=[So;so+i];
end
yS1=y1(Si1,:);

%tstart = tic;


RB=zeros(2*N2*N1,N1);
RB(1:N1,:)=A0(1:N1,:)';
for i=N2-1:-1:1;
  RB((N2+1)*N1+1+(N2-1-i)*N1:(N2+1)*N1+(N2-i)*N1,:)= ...
    A0(N1*i+1:N1*(i+1),:)'; % check this preallocate memory
end

AS1=(RB(Si1,:));

t01=tic;
BLyS1=zeros(2*N1*N2,N1); % giati N1 kai oxi q ?
for i=1:q;
  bl_yS1=reshape(yS1(:,i),[2*N2,N1]);
  FyS1=fft(bl_yS1);
  BLyS1(:,i)=reshape(FyS1,[2*N1*N2,1]);
end

xSx=zeros(N1*N2,q);
for i=1:N1
  t01=tic;
  AAA= AS1(1+(i-1)*2*N2:i*2*N2,:) ;
  %size(AAA)
  FSA1=fft( AAA);
  X1=zeros(2*N2,q);
  for k=1:q
    RFyS1=reshape(BLyS1(:,k),[2*N2,N1]);
    FD=FSA1.*RFyS1;
    FD=sum(FD,2);
    X1(:,k)=ifft(FD);
  end
  
  X1=X1(1:N2,:);
  xSx(1+(i-1)*N2:i*N2,:)=X1;
end
xout=xSx(So,:);
y1=[xout;zeros(N1*N2,q)];

%telapsed2 = toc(tstart)


yS1=y1(Si1,:);



AS1=A1(Si1,:);

BLyS1=zeros(2*N1*N2,N1);
for i=1:q;
  bl_yS1=reshape(yS1(:,i),[2*N2,N1]);
  FyS1=fft(bl_yS1);
  BLyS1(:,i)=reshape(FyS1,[2*N1*N2,1]);
end
xSx=zeros(N1*N2,q);
for i=1:N1
  FSA1=fft(AS1(1+(i-1)*2*N2:i*2*N2,:));
  X1=zeros(2*N2,q);
  for k=1:q
    RFyS1=reshape(BLyS1(:,k),[2*N2,N1]);
    FD=FSA1.*RFyS1;
    FD=sum(FD,2);
    X1(:,k)=ifft(FD);
  end
  X1=X1(1:N2,:);
  xSx(1+(i-1)*N2:i*N2,:)=X1;
end
xoutA=xSx(So,:);


A0=[zeros(N1,N1);B(1:(N2-1)*N1,:)];
A1=[A0;zeros(N1*N2,N1)];
y1=[y0;zeros(N1*N2,q)];

yS1=y1(Si1,:);

RB=zeros(2*N2*N1,N1);
RB(1:N1,:)=A0(1:N1,:)';
for i=N2-1:-1:1;
  RB((N2+1)*N1+1+(N2-1-i)*N1:(N2+1)*N1+(N2-i)*N1,:)= ...
    A0(N1*i+1:N1*(i+1),:)'; % check this preallocate memory
end

% RB=[A0(1:N1,:)'; zeros(N2*N1,N1)];
% for i=N2-1:-1:1;
%     RB=[RB; A0(N1*i+1:N1*(i+1),:)']; % concatenation
% end
AS1=(RB(Si1,:));

BLyS1=zeros(2*N1*N2,N1);
for i=1:q;
  bl_yS1=reshape(yS1(:,i),[2*N2,N1]);
  FyS1=fft(bl_yS1);
  BLyS1(:,i)=reshape(FyS1,[2*N1*N2,1]);
end
xSx=zeros(N1*N2,q);
for i=1:N1
  FSA1=fft(AS1(1+(i-1)*2*N2:i*2*N2,:));
  X1=zeros(2*N2,q);
  for k=1:q
    RFyS1=reshape(BLyS1(:,k),[2*N2,N1]);
    FD=FSA1.*RFyS1;
    FD=sum(FD,2);
    X1(:,k)=ifft(FD);
  end
  X1=X1(1:N2,:);
  xSx(1+(i-1)*N2:i*N2,:)=X1;
end
xout=xSx(So,:);
y1=[xout;zeros(N1*N2,q)];
yS1=y1(Si1,:);

AS1=A1(Si1,:);

BLyS1=zeros(2*N1*N2,N1);
for i=1:q;
  bl_yS1=reshape(yS1(:,i),[2*N2,N1]);
  FyS1=fft(bl_yS1);
  BLyS1(:,i)=reshape(FyS1,[2*N1*N2,1]);
end
xSx=zeros(N1*N2,q);
for i=1:N1
  FSA1=fft(AS1(1+(i-1)*2*N2:i*2*N2,:));
  X1=zeros(2*N2,q);
  for k=1:q
    RFyS1=reshape(BLyS1(:,k),[2*N2,N1]);
    FD=FSA1.*RFyS1;
    FD=sum(FD,2);
    X1(:,k)=ifft(FD);
  end
  X1=X1(1:N2,:);
  xSx(1+(i-1)*N2:i*N2,:)=X1;
end
xoutB=xSx(So,:);

xout=xoutA-xoutB;
